module Main.Type
  ( Expr (..),
  -- AST (..)
  )
where

import Data.Graph (Tree (Node))

data Expr
  = Lit Int
  | Paren Expr
  | Add Expr Expr
  | Sub Expr Expr
  | Mul Expr Expr
  | Div Expr Expr
  | Print Expr
  deriving
    ( Show
    )

-- data AST = AST Node

-- data Node
--   = Reg
--       { cur :: Expr,
--         next :: Node
--       }
--   | End
--       { cur :: Expr
--       }